import os
import tempfile

from src.aws.s3 import BackupBucket
from src.config.objects import TargetObject
from src.error.exceptions import FileUploadException
from src.system_var.constants import CSVBK_JP_NAME, TEMPORARY_FILENAME
from src.util.execute_datetime import ExecuteDateTime
from src.util.logger import logger_instance as logger
from src.writer.file_writer import CsvWriter


def backup_crm_csv_data_process(target_object: TargetObject, execute_datetime: ExecuteDateTime, csv_data: list):
    """CSVバックアップ処理

    Args:
        target_object (TargetObject): 取得対象オブジェクト情報インスタンス
        execute_datetime (ExecuteDateTime): 実行日時取得インスタンス
        csv_data (list): csvデータ

    Raises:
        FileUploadException: S3のファイルアップロード失敗
    """

    # ① CSVバックアップ処理の開始ログを出力する
    target_object_name = target_object.object_name
    upload_file_name = target_object.upload_file_name
    upload_file_key = f'{execute_datetime.to_path()}/{upload_file_name}.csv'

    logger.info(
        f'I-CSVBK-01 [{target_object_name}] のCSVデータのバックアップ処理を開始します  ファイル名：[{upload_file_name}.csv]')
    try:
        # ② CRMバックアップ保管用バケットに、変換後のCSVデータのバックアップを保管する
        _backup_csv_file(target_object_name, upload_file_key, csv_data)
    except Exception as e:
        raise FileUploadException(
            'E-CSVBK-01',
            CSVBK_JP_NAME, f'[{target_object_name}] CSVデータのバックアップに失敗しました ファイル名：[{upload_file_name}.csv] エラー内容:[{e}]')
    # ③ CSVバックアップ処理の終了ログを出力する
    logger.info(
        f'I-CSVBK-03 [{target_object_name}] のCSVデータのバックアップ処理を終了します')

    # ④ 次の処理へ移行する
    return


def _backup_csv_file(target_object_name: str, upload_file_key: str, csv_data: list) -> None:

    # 一時ファイル書き込み用の領域を確保
    with tempfile.TemporaryDirectory(prefix=f'{target_object_name}_') as tmpdir:
        # アップロード用のファイルをローカルに書き出す
        local_file_path = os.path.join(tmpdir, TEMPORARY_FILENAME)
        writer = CsvWriter(local_file_path, csv_data)
        writer.write()
        # ファイルからS3に書き込み
        backup_bucket = BackupBucket()
        backup_bucket.put_csv(upload_file_key, local_file_path)

    logger.debug(
        f'D-CSVBK-02 [{upload_file_key}] のCSVデータバックアップ 正常終了')

    return
